package ocl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.List;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EPackageRegistryImpl;
import org.eclipse.ocl.OCLInput;
import org.eclipse.ocl.ParserException;
import org.eclipse.ocl.ecore.Constraint;
import org.eclipse.ocl.ecore.EcoreEnvironmentFactory;
import org.eclipse.ocl.ecore.OCL;
import org.eclipse.ocl.ecore.OCL.Query;

import example.ExamplePackage;

public class ExampleOclUtil {
	private OCL ocl;
	private File file;
	private FileInputStream inputStream;
	private OCLInput oclInput;
	private EPackage.Registry registry;
	private EcoreEnvironmentFactory environmentFactory;
	
	
	public ExampleOclUtil(){
		registry = new EPackageRegistryImpl();
		registry.put(ExamplePackage.eNS_URI, ExamplePackage.eINSTANCE);
		environmentFactory = new EcoreEnvironmentFactory(registry);
		ocl = OCL.newInstance(environmentFactory);
	}
	
	public List<Constraint> getConstraints(String path) throws ParserException, FileNotFoundException{
		file = new File(path);
		inputStream = new FileInputStream(file);
		oclInput = new OCLInput(inputStream);
		return ocl.parse(oclInput);
	}
	
	public Query evaluate(Constraint constraint){
		return ocl.createQuery(constraint);
	}
}