package ocl;

import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import example.ExamplePackage;
import example.Model;

public class ExampleXMILoader {
	
	private ExampleXMILoader(){}
	private static ExampleXMILoader INSTANCE;
	
	public static ExampleXMILoader getInstance(){
		if(INSTANCE == null)INSTANCE = new ExampleXMILoader();
		return INSTANCE;
	}
	
	/** load the model from XMI */
	public Model loadModel(){
		//initialize the model
		ExamplePackage.eINSTANCE.eClass();
		
		//register the XMI resource factory for the .xmi extension
		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;
		Map<String, Object> m = reg.getExtensionToFactoryMap();
		m.put("xmi", new XMIResourceFactoryImpl());
		
		//obtain new resource set and get the resource
		ResourceSet resourceSet = new ResourceSetImpl();
		Resource resource = resourceSet.getResource(URI.createURI("model/Model.xmi"), true);
		return (Model)resource.getContents().get(0);
	}
}