package ocl;

import java.util.List;

import org.eclipse.ocl.ecore.Constraint;
import org.eclipse.ocl.ecore.OCL.Query;

import example.ClassA;
import example.Element;
import example.Model;

public class Main {
	public static void main(String[] args) throws Exception{
		
		ExampleOclUtil util = new ExampleOclUtil();		
		Model model = ExampleXMILoader.getInstance().loadModel();
		
		try{
			List<Constraint> constraints = util.getConstraints("model/Model.ocl");
			for(Constraint c: constraints){
				Query constraintQuery = util.evaluate(c);
				for(Element e: model.getElements()){
					if(e instanceof ClassA){
						System.out.println("Evaluation on class: " + e.getName());
						System.out.println("Result: " + constraintQuery.check(e));
					}
				}
			}
		}catch(Exception e){System.out.println("ERROR OCCURED: ");e.printStackTrace();}
	}
}